program Kill-ids;
  {Fixes ids.bbs file to new format   }


  type
    name      = string[14];
    line      = string[80];
    person    = string[27];
    longname  = string[35];
    call      = string[8];

 sysid  = record
                user: person;
                exfl: byte;
                lsto: name;
                lstm: integer;
                pass: name;
                acc:  byte;
                clr:  name;
                bsp:  char;
                lnf:  char;
                upc:  boolean;
                wid:  byte;
           address1:  longname;
           address2:  longname;
           callsign:  call;
          telephone:  name;
     end;

var infile : file of sysid;
   outfile : file of sysid;
     idrec : sysid;
     ch    : char;
     s     : string[35];
type sx  = string[20];

procedure reset_data(reason : sx);
 begin
       writeln(lst,
                  idrec.user,'  ',
                  idrec.lsto,'  ',
                  reason, '  ',
                  idrec.callsign);
       idrec.user := '***';
       idrec.acc  := 0;
       idrec.address1 := 'NO Street Address...';
       idrec.address2 := 'NO City,State ZIP...';
       idrec.callsign := 'NONE';
       idrec.telephone := '(___) ___-____';
       idrec.pass := ' ';
 end;

procedure fixcall;
var i : integer;
begin
  read(infile, idrec);
  for i := 1 to length(idrec.callsign) do
        idrec.callsign[i] := upcase(idrec.callsign[i]);
   write(outfile,idrec);
end;


procedure Delete_Old_users;
var i,j, bad_count : integer;
begin
  bad_count := 0;
  read(infile, idrec);

  { FIRST TEST FOR BAD USER }
  if idrec.acc = 0 then reset_data('Access=0');

  { SECOND TEST FOR NO INFOMATION INPUTTER  }
  if (copy(idrec.telephone,1,2)  = '(_'  ) then bad_count := bad_count + 1;
  if (copy(idrec.address1, 1,2)  = 'NO'  ) then bad_count := bad_count + 1;
  if (copy(idrec.address2, 1,2)  = 'NO'  ) then bad_count := bad_count + 1;
  if bad_count >1 then reset_data('Bad_count');

  { THIRD TEST FOR NON-HAM CALLSIGN  }
  i := 0;
  j := length(idrec.callsign);
  repeat
    i := i + 1;
  until ((idrec.callsign[i] in ['0'..'9']) or (i=j));
  if (i=j) then idrec.callsign := 'NONE';

 { FORTH TEST FOR NON-ACTIVITY FOR SEVERAL MONTHS }
 if idrec.acc < 4 then
 begin
    if (copy(idrec.lsto,10,3) = 'Mar') then reset_data('No Activity');
    if ((copy(idrec.lsto,10,3) = 'Apr') and (idrec.acc < 3))
           then reset_data('No Activity');
 end;

  write(outfile,idrec)
end;

procedure Fix;
begin
    read(infile, idrec);
    if (length(idrec.user) < 4) or (copy(idrec.user,1,3) = '   ') then

  write(outfile,idrec)
end;

  begin
      s := '                                   ';
      assign(infile,'\bbs\ids.bbs');
      assign(outfile,'\bbs\idsnew.bbs');
      {$I-} rewrite(outfile) {$I+};
      if ioresult <> 0 then Halt;
      {$I-} reset(infile) {$I+};
      if ioresult = 0 then
      begin
         while not eof(infile) do
         begin
            Delete_Old_Users;     { Deletes users that don't input data }
         {  fix;        }
         {  fixcall; }
         end;
      end;
      close(outfile);
      close(infile);
      writeln('Finished with update');
   end.


