
procedure filelist(inputx : longname);

var   DirInfo: TSearchRec;
      ix     : array[0..21] of char;
      path   : array[0..fspathname] of char;
      dir    : array[0..fsDirectory] of char;
      name   : array[0..fsfilename] of char;
      ext    : array[0..fsextension] of char;
      i      : integer;
 Num_Entries : integer;
const
   cr = #13;
type
   fname_type   = record
                    name   : string[8];
                    ext    : string[4];
                  end;
var
   current_dir   : array [1..500] of fname_type;


Procedure sort_directory (num_entries : integer);
var
  nochange   : boolean;
  temp1      : fname_type;
  x          : integer;
begin
 { stringout (' Sorting');  }
  repeat
   { stringout ('.');  }
    nochange := true;
    for x := 1 to num_entries - 1 do
      if current_dir[x].name > current_dir[x+1].name then
        begin
          temp1 := current_dir[x];
          current_dir[x] := current_dir[x+1];
          current_dir[x+1] := temp1;
          nochange := false;
        end
      else
        if current_dir[x].name = current_dir[x+1].name then
          if current_dir[x].ext > current_dir[x+1].ext then
            begin
              temp1 := current_dir[x];
              current_dir[x] := current_dir[x+1];
              current_dir[x+1] := temp1;
              nochange := false;
            end;
    num_entries := num_entries - 1;
  until nochange;
{  lineout ('done '); }
end;



Procedure show_directory(Number_of_entries : integer);
var x,y : integer;
begin
  lineout(cr);
  for x := 1 to 5 do stringout ('Name     Ext   ');
  lineout(cr);
  for x := 1 to 5 do
  begin
    for y := 1 to 12 do stringout('-');
    for y := 1 to 3  do stringout(' ');
  end;
  lineout(cr);
  for x := 1 to number_of_entries do
    begin
      if (x <> 1) then lineout(cr);
      for y := 0 to 4 do
      begin
         with current_dir[x+y] do stringout(name + ext);
         stringout('   ');
         if (x+y = number_of_entries) then
         begin
             lineout(cr);
             exit;
         end;
      end;
      x := x + 4;
    end;
  lineout(cr);
end;

begin
   num_entries := 0;
   StrPCopy(Ix,inputx);
   FindFirst(Ix,faArchive,DirInfo);
   While DosError = 0 do
   begin
     filesplit(DirInfo.name,dir,name,ext);
     num_entries := num_entries + 1;
     Current_dir[num_entries].name := copy(strpas(name) + sp,1,8);
     Current_dir[num_entries].ext  := copy(strpas(ext)  + sp,1,4);
     FindNext(DirInfo);
   end;
   sort_directory (num_entries);
   show_directory(num_entries);
   lineout('Files Processed = '+ IString(num_entries));
end;