program LISTFILE;
type   regpack = record
              ax,bx,cx,dx,bp,si,di,ds,es,flags: integer;
            end;
var  recpack : regpack;

    data      : string[254];
    line     : string[254];
    type longline = string[254];

var idfile : text ;
     ch : char;
procedure INT10(al,ah,bl,bh,cl,ch,dl,dh: byte);
begin
  with recpack do
  begin
    ax := ah shl 8 + al;
    bx := bh shl 8 + bl;
    cx := ch shl 8 + cl;
    dx := dh shl 8 + dl;
  end;
  intr($10,recpack);                     {call interrupt}
end;

procedure increment_Y;
var x,y : integer;
begin
   with recpack do
   begin
     INT10(0,$03,0,0,0,0,0,0);
     y := dx shr 8;
     x := dx and $ff;
     y := y + 1;
     x := 0;
     if y > 42 then
     begin
       INT10(1,$06,0,0,0,0,131,42);   {scroll}
       x := 0;
       y := 42;
     end;
     int10(0,$02,0,0,0,0,x,y);       {place curser on next line}
   end;
 end;

procedure increment_X;
var x,y : integer;
begin
  with recpack do
  begin
    INT10(0,$03,0,0,0,0,0,0);
    y := dx  shr 8;
    x := dx and $ff;
    if x = 132 then increment_Y else
    begin
      x := x + 1;
      INT10(0,$02,0,0,0,0,x,y);
    end;
  end;
end;

var kolor : integer;

procedure _write(by : char);
begin
  INT10(ord(by),$09,Kolor,$00,1,0,0,0);
  increment_X;
end;

procedure _writeln(xline : longline);
var i : integer;
begin
  for i := 1 to length(xline) do _write(xline[i]);
  increment_Y;
end;

procedure HiRes;
begin
  INT10($54,$00,0,0,0,0,0,0);
end;
procedure LowRes;
begin
  INT10($03,$00,0,0,0,0,0,0);
end;

procedure background(color : integer);
begin
  INT10(0,$0B,color,0,0,0,0,0);
end;


procedure listing(Xcopy : char);
  begin
      assign(idfile,'\bbs\files\ws7mcode.bbs');
      {$I-} reset(idfile) {$I+};
      if ioresult = 0 then
      begin
        while not eof(idfile) do
        begin
            readln(idfile, data);
            _writeln(data);
        end;
      end;
      close(idfile);
      _writeln('Finished with listing');
   end;

begin { main }
  HiRes;
  kolor := green;
  background(lightgray);
  listing(ch);
  read(ch);
  LowRes;
end.

