program LISTIDS;
  {LIST IDSFILE, COPY TO ANOTHER FILE. }

type
  regpack = record
              ax,bx,cx,dx,bp,si,di,ds,es,flags: integer;
            end;
var  recpack : regpack;
     writefile : text;

  type
    name      = string[14];
    line      = string[254];
    person    = string[27];
    longname  = string[35];
    call      = string[8];


 sysid  = record
                user: person;
                exfl: byte;
                lsto: name;
                lstm: integer;
                pass: name;
                acc:  byte;
                clr:  name;
                bsp:  char;
                lnf:  char;
                upc:  boolean;
                wid:  byte;
           address1:  longname;
           address2:  longname;
           callsign:  call;
          telephone: name;
     end;



var idfile : file of sysid;
     idrec : sysid;
     ch    : char;
     sp    : string[60];
     item  : integer;
     page  : integer;
     inch  : char;
     Kolor : integer;


procedure INT10(al,ah,bl,bh,cl,ch,dl,dh: byte);
begin
  with recpack do
  begin
    ax := ah shl 8 + al;
    bx := bh shl 8 + bl;
    cx := ch shl 8 + cl;
    dx := dh shl 8 + dl;
  end;
  intr($10,recpack);                     {call interrupt}
end;

procedure increment_Y;
var x,y : integer;
begin
   with recpack do
   begin
     INT10(0,$03,0,0,0,0,0,0);
     y := dx shr 8;
     x := dx and $ff;
     y := y + 1;
     x := 0;
     if y > 42 then
     begin
       INT10(1,$06,0,0,0,0,131,42);   {scroll}
       x := 0;
       y := 42;
     end;
     int10(0,$02,0,0,0,0,x,y);       {place curser on next line}
   end;
 end;

procedure increment_X;
var x,y : integer;
begin
  with recpack do
  begin
    INT10(0,$03,0,0,0,0,0,0);
    y := dx  shr 8;
    x := dx and $ff;
    if x = 132 then increment_Y else
    begin
      x := x + 1;
      INT10(0,$02,0,0,0,0,x,y);
    end;
  end;
end;

procedure _write(by : byte);
begin
  INT10(by,$09,Kolor,$00,1,0,0,0);
  increment_X;
end;

procedure _writeln(xline : line);
var i : integer;
begin
  for i := 1 to length(xline) do _write(ord(xline[i]));
  increment_Y;
end;

procedure HiRes;
begin
  INT10($54,$00,0,0,0,0,0,0);
end;
procedure LowRes;
begin
  INT10($03,$00,0,0,0,0,0,0);
end;

procedure background(color : integer);
begin
  INT10(0,$0B,color,0,0,0,0,0);
end;


procedure listing(Xcopy : char);
var short : string[4];
       ss : string[1];
  begin
      sp        := '                                            ';
      assign(idfile,'\bbs\ids.bbs');
      assign(writefile,'d:\public\bbslist.txt');
      {$I-} reset(idfile) {$I+};
      {$I-} rewrite(writefile); {$I+}
      if ioresult = 0 then
      begin
         item := 1;
         page := 1;
       {   if Xcopy = 'H' then write(lst,#27,#143);  }
         while not eof(idfile) do
         begin
           WITH IDREC DO
           BEGIN
             read(idfile, idrec);
             str(ord(acc),ss);
             if Xcopy = 'H' then writeln({lst} writefile,
                item:4,' ',
                copy(ss       +sp,1,3),
                copy(user     +sp,1,27),
                copy(callsign +sp,1,9),
                copy(address1 +sp,1,34),
                copy(address2 +sp,1,34),
                copy(telephone+sp,1,15),
             {   copy(pass     +sp,1,13),  }
                lsto);
              str(item:4,short);
              case acc of
              0 : kolor :=lightblue;
              1 : kolor :=green;
              2 : kolor :=darkgray;
              3 : kolor :=brown;
              4 : kolor :=red;
              5 : kolor :=white;
              end; {
             _writeln(
                short +   ' ' +
                ss + ' ' +
                copy(user     +sp,1,21) +
                copy(callsign +sp,1,9)  +
                copy(address1 +sp,1,34) +
                copy(address2 +sp,1,33) +
                copy(telephone+sp,1,15) +
                copy(pass     +sp,1,13)
                );  }
             item := item + 1;
             page := page + 1;
             if ((page = 41) and (Xcopy = 'S')) then
             begin
               page := 1;
               read(kbd,ch);
             end;
             {
             if ((page = 60) and (Xcopy = 'H')) then
             begin
               page := 1;
               write(lst,#27,#12);
             end;   }
           END;
         end;
      end;
      if Xcopy = 'H' then close(writefile); {write(lst,#27,#146);  }
      close(idfile);
      Kolor := blue;
      _writeln('Finished with listing');
   end;

begin { main }
  repeat
    write('Do you want [H]ardcopy or [S]oftcopy? :');
    read(ch);
    ch := upcase(ch);
  until ch in['H','S'];
  HiRes;
  background(lightgray);
  listing(ch);
  read(ch);
  LowRes;
end.


