{ NOS }

{=======================  MSYS ===================}

function datardy_MSYS: boolean;
var Stat: TComStat;
begin
  GetCommError(NOSBase, Stat);
  datardy_MSYS := Stat.cbInQue > 0;
end;

Function  recvchar_MSYS: char;
var c : char;
Begin
 if datardy_MSYS then
  begin
     ReadComm(NOSBase, @C, 1);
     recvchar_MSYS := C ;
  end;
end;

procedure xmitchar_MSYS(ch : char);
Var LSRreg: byte;
begin
  repeat
    WindowsMessageHandler;
  until (WriteComm(NOSBase, @ch, 1) = 1);
end;

procedure stringout_MSYS(message : line);
var charpos : integer;
begin
for charpos := 1 to length(message) do
  begin
     xmitchar_MSYS(message[charpos]);
     delay(20);   { add 20 ms time for 9600 baud to clear   }
  end;
end;

function cts_MSYS: boolean;
  begin
    cts_MSYS := ((Port[NOSAddress+MSR] and $20) = $20);
 end;

function dsr_MSYS: boolean;
  begin
    dsr_MSYS := ((Port[NOSAddress+MSR] and $20) = $20);
 end;

procedure dropRTS_MSYS;
{ Lowers RS-232 RTS line - used to inhibit auto-answer
   and to cause modem to hang up }
  begin
    EscapeCommFunction(NOSBase,ClrRTS);      {  Reset RTS, DTR, OUT2       }
    EscapeCommFunction(NOSBase,ClrDTR);
    writeln('dropRTS_MSYS...');
  end;

procedure raiseRTS_MSYS;
{ Raises RS-232 RTS line - used to enable auto-answer
   and to cause modem to hang up }
  begin
   EscapeCommFunction(NOSBase,SetRTS);     {  Reset RTS, DTR, OUT2       }
   EscapeCommFunction(NOSBase,SetDTR);
   writeln('raiseRTS_MSYS...');
  end;



{=======================  END  MSYS  ===================}

function inchar: char;
var temp: char;
begin
  repeat until inready or not cts;
  if keypressed then temp := readkey else temp := recvchar;
  inchar := temp;
end;


procedure MSYS;
var inch,
    inch1 : char;
    junky : boolean;
    destination : text;
    tempcall : string[10];
    i,counttime    : integer;

    procedure get_semicolon;
    begin
    inch1 := null;
   { Routine to wait for ':' from NOS BBS }
    while (cts_MSYS and cts and (inch <> ^T) and (inch1 <> ':')) do
    begin
      { echo TNC characters to the caller   }
        if inready then
      begin
        inch := inchar;
        xmitchar_MSYS(inch);
      end;
      if datardy_MSYS then
      begin
         inch1 := recvchar_MSYS;
         if (local or ScreenControlx)
              then sendout(inch1) else xmitchar(inch1);
      end;
      WindowsMessageHandler;
      if TimeOutTimer then
       begin
         counttime := counttime + 1;
         TimeOutTimer := false;
         SetTimer(CrtWindow,0,10000,nil);
       end;
      if counttime > 2 then
      begin
        lineout(cr+lf+'SystemBBS has detected Bridge Failure and has timed out...');
        StatusLine(1,'System timeout: 30 seconds');
        inch := ^T;
      end;
     end;
    end;



  begin
    lineout('Entering TCIP Network Operating System...'+cr);
    inch := null;
    clearsc;
    tempcall := calls;
    if (( not expert) and (access <> HAM_bbs))
           then outfile(JNOSInfo);
    File_Control_Enable := false;
    if calls = 'NONE' then tempcall := 'A5AAA';
    if access < HAM_MSYS then tempcall := 'A5AAA';
    if tempcall = 'A5AAA' then
    begin
       lineout('Please use temporary guest callsign A5AAA...');
       lineout('Send note to SYSOP to upgrade your user level...');
    end;
    i := pos('-',tempcall);
    if i<> 0 then tempcall := copy(tempcall,1,i-1);
    i := pos('/',calls);
    if i<> 0 then tempcall := copy(tempcall,1,i-1);
   (*** temp fix for NOS
    assign(destination,MSYSPassword);
    {$I-} rewrite(destination); {$I+}
    if IORESULT = 0 then
    begin
      verylongname := tempcall + ' ' + tempcall + ' '+ tempcall;
      writeln(destination,verylongname);
      close(destination);
    end;
    lineout('Your MSYS callsign is [' + tempcall + ']');
    lineout('Your MSYS password is [' + tempcall + ']');
    *** end NOS Delete   *)
    FlushComm(Nosbase,0);
    flush;
    Junky := cts_MSYS;
    File_Control_Enable := False;
    TimeOutTimer := false;
    counttime := 0;
    SetTimer(CrtWindow,0,10000,nil);
    raiseRTS_MSYS;
    get_semicolon;
    if (inch <> ^T) then stringout_MSYS(tempcall + cr);
    get_semicolon;
    if (inch <> ^T) then stringout_MSYS(password + cr);

    { main loop program }
    while (cts_MSYS and cts and (inch <> ^T)) do
    begin
      WindowsMessageHandler;
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      { echo inready characters to the TNC }
      if inready then
      begin
        counttime := 0;
        KillTimer(CrtWindow,0);
        TimeOutTimer := false;
        SetTimer(CrtWindow,0,10000,nil);
        inch := inchar;
        xmitchar_MSYS(inch);
      end;

     { echo TNC characters to the caller   }
     if datardy_MSYS then
     begin
        counttime := 0;
        KillTimer(CrtWindow,0);
        TimeOutTimer := false;
        SetTimer(CrtWindow,0,10000,nil);
        inch1 := recvchar_MSYS;
        if (local or ScreenControlx)
             then sendout(inch1) else xmitchar(inch1);
     end;

     if TimeOutTimer then
      begin
        counttime := counttime + 1;
        TimeOutTimer := false;
        SetTimer(CrtWindow,0,10000,nil);
      end;
     if counttime > 48 then
     begin
       lineout(cr+lf+'SystemBBS has detected lack of activity and has timed out...');
       StatusLine(1,'System timeout: 8 minutes');
       inch := ^T;
     end;

  end;

  File_Control_Enable := True;
  junky := cts_MSYS;
  delay(1000);
  while datardy_MSYS do
  begin
     inch1 := recvchar_MSYS;
     if (local or ScreenControlx)
          then sendout(inch1) else xmitchar(inch1);
  end;
  lineout(cr +lf + 'Exiting TCPIP NOS Packet mode.');
{  if (not cts_MSYS) then writeln('ERROR: cts_MSYS lost...');
  if (not cts)      then writeln('ERROR: cts carrier lost...');  }
  dropRTS_MSYS;
 end;

procedure XPacketMenu;
var prompt : line;
      inch : char;
begin
 StatusLine(1,'PacketMenu...');
 Statusline1(2,'...');
 StatusLine1(3,'...');
 StatusLine1(4,'...');
  repeat
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if ((not expert) and (inbuffer = '')) then outfile(Packmenu);
      File_Control_Enable := false;
      prompt := cr + lf + 'main\PACKET MENU: ';
      if expert then prompt := prompt + '[Y,T,?,-] : ';
      inch := getcap(prompt);
      case inch of
       'Y': begin
               if access < HAM_Gate then lineout('You are not a registered HAM Gate User.')
               else begin Statusline1(2,'TCPIP NOS Bridge'); MSYS; end;
            end;
       'T': TCPIP(0);
       '?': outfile(Packmenu);
       '-': begin end;
       cr : begin end;
       else ErrorCode(inch);
     end;
    until ((inch ='-') or (inch = cr) or not cts);
end;

{eof}