{$M 42900,4000}

program PLIST;
uses wincrt,strings;

const
     maxTCPIPmessage = 250;
type
       TCPIPRecordType = record
           startline : integer;
           endline   : integer;
           SubjectTitle : string[60];
        end;
var
       TCPIPRecord : array[1..250] of TCPIPRecordType;
       messagecount : integer;

procedure gettitles(filename :string);
var
       line        : string[128];
       infile      : text;
       start       : boolean;
       index,colon,linenumber : integer;
begin
      linenumber := 0;
      messagecount := 1;
      start := false;
      assign(infile,filename);
      {$I-} reset(infile) {$I+};
      if ioresult <> 0 then
      begin
        writeln('Could not find input file');
        exit;
      end;
      while not eof(infile) do
      begin
          readln(infile, line);
          linenumber := linenumber + 1;

          index := pos('Subject:',line);
          colon := pos(':',line) + 1;
          if (index =1) then TCPIPRecord[messagecount].SubjectTitle :=
                   copy(line,colon,colon + 60);

          { Look for first 'from' in position one   }
          if  (pos('From ',line) = 1) then  start := true;

          {  Check for end of header- last received }
          index := pos('Received:',line);
          if index = 1 then TCPIPRecord[messagecount].startline := linenumber+2;

          if (start and (length(line)=0)) then start := false ;
          if not start then   { find end of text in document }
          begin
            start := true;
            repeat
               readln(infile, line);
               linenumber := linenumber + 1;
            until ((pos('From ',line) = 1) or eof(infile));
            TCPIPRecord[messagecount].endline := linenumber - 1;
            messagecount := messagecount + 1;
            if (pos('From ',line) = 1)  then TCPIPRecord[messagecount].startline := linenumber;
            if (messagecount > maxTCPIPmessage) then exit;
          end;    { loop to skip message text }
      end;        { loop to read file  }
      messagecount := messagecount - 1;
      close(infile);
end;


procedure listtitles;
var count : integer;
begin
   for count := 1 to messagecount do
    writeln(count:3,' ',
           TCPIPRecord[count].startline:4,' ',
           TCPIPRecord[count].endline:4,' ',
           TCPIPRecord[count].SubjectTitle);
   writeln('Finis...');
   writeln;
end;

procedure readmessage(filename: string; message:integer);
var linenumber : integer;
      infile      : text;
      line        : string[128];
type
     badwords = array[1..11] of string[21];
const
      badword : badwords =
            ('Path:',
             'Newsgroups:',
             'Keywords:',
             'Message-ID:',
             'Article-I.D.:',
             'References:',
             'NNTP-Posting-Host:',
             'Errors-To:',
             'Precedence:',
             'Message-Id:',
             'Status:');
 var  badcount,i : integer;

begin
      linenumber := 1;
      assign(infile,filename);
      {$I-} reset(infile) {$I+};
      if ioresult <> 0 then
      begin
        writeln('Could not find input file');
        exit;
      end;
      while ((not eof(infile)) and (linenumber < TCPIPRecord[message].endline)) do
      begin
          readln(infile, line);
          if linenumber >= TCPIPRecord[message].startline then
          begin
            badcount := 0;
            for i := 1 to 11 do badcount := badcount + pos(badword[i],line);
            if badcount = 0 then writeln(line);
          end;
          linenumber := linenumber + 1;
      end;        { loop to read file  }
      close(infile);
      writeln('Finis...');
end;


begin

   screensize.x := 80;
      screensize.y := 500;


  gettitles('\spool\mail\aa6ed2.txt');
  listtitles;
 { readmessage('\spool\mail\aa6ed1.txt',15);
  readmessage('\spool\mail\aa6ed1.txt',1);
  readmessage('\spool\mail\aa6ed1.txt',10);
  readmessage('\spool\mail\aa6ed1.txt',60);  }
end.