program sort;
  {LIST IDSFILE, COPY TO ANOTHER FILE. }


  type
    name      = string[14];
    line      = string[254];
    person    = string[27];
    longname  = string[35];
    call      = string[8];

 sysid  = record
                user: person;
                exfl: byte;
                lsto: name;
                lstm: integer;
                pass: name;
                acc:  byte;
                clr:  name;
                bsp:  char;
                lnf:  char;
                upc:  boolean;
                wid:  byte;
           address1:  longname;
           address2:  longname;
           callsign:  call;
          telephone: name;
     end;



var idfile : file of sysid;
     idrec : sysid;
     ch    : char;
     sp    : string[60];
     item  : integer;
     num_entries : integer;
     page  : integer;
     inch  : char;
     storage : array[1..340] of sysid;

procedure listfile;
 var x : integer;
begin
  for x := 1 to item - 1 do
  begin
    with storage[x] do
    writeln( lst,
             lstm:4 ,   ' ' ,
             acc:1 , ' ' +
             copy(user     +sp,1,21) +
             copy(callsign +sp,1,9)  +{
             copy(address1 +sp,1,34) +
             copy(address2 +sp,1,33)    +}
             copy(telephone+sp,1,15)   );
  end;
end;

procedure listsoft;
 var x : integer;
begin
  for x := 1 to item - 1 do
  begin
    with storage[x] do
    writeln(
             lstm:4 ,   ' ' ,
             acc:1 , ' ' +
             copy(user     +sp,1,21) +
             copy(callsign +sp,1,9)  +{
             copy(address1 +sp,1,34) +
             copy(address2 +sp,1,33)    +}
             copy(telephone+sp,1,15)   );
  end;
end;

procedure listcall;
 var x : integer;
begin
  for x := 1 to item - 1 do
  begin
    with storage[x] do
    if callsign <> 'NONE' then writeln(  lst,
             lstm:4 ,   ' ' ,
             acc:1 , ' ' +
             copy(user     +sp,1,21) +
             copy(callsign +sp,1,9)  +{
             copy(address1 +sp,1,34) +
             copy(address2 +sp,1,33)    +}
             copy(telephone+sp,1,15)   );
  end;
end;

Procedure sortname;
var
  nochange   : boolean;
  temp1      : sysid;
  x          : integer;

begin    {this is a cheap bubble sort... of sorts (bad pun!) }
  write(' Sorting');
  repeat
    write ('.');
    nochange := true;
    for x := 1 to num_entries - 1 do
      if storage[x].user > storage[x+1].user then
        begin
          temp1 := storage[x];
          storage[x] := storage[x+1];
          storage[x+1] := temp1;
          nochange := false;
        end;
    num_entries := num_entries - 1;
  until nochange;
  writeln ('done ');
end;

Procedure sortcall;
var
  nochange   : boolean;
  temp1      : sysid;
  x          : integer;

begin    {this is a cheap bubble sort... of sorts (bad pun!) }
  write(' Sorting');
  repeat
    write ('.');
    nochange := true;
    for x := 1 to num_entries - 1 do
      if storage[x].callsign > storage[x+1].callsign then
        begin
          temp1 := storage[x];
          storage[x] := storage[x+1];
          storage[x+1] := temp1;
          nochange := false;
        end;
    num_entries := num_entries - 1;
  until nochange;
  writeln ('done ');
end;



procedure readfile;
var short : string[4];
       ss : string[1];
       i : integer;
  begin
      sp        := '                                            ';
      assign(idfile,'\bbs\ids.bbs');
      {$I-} reset(idfile) {$I+};
      if ioresult = 0 then
      begin
         num_entries := 1;
         item := 1;
         while not eof(idfile) do
         begin
           WITH IDREC DO
           BEGIN
             read(idfile, idrec);
             for i := 1 to length(callsign) do callsign[i] := upcase(callsign[i]);
             storage[item] := idrec;
             storage[item].lstm := item;
             num_entries := num_entries + 1;
              item := item + 1;
           END;
         end;
      end;
      close(idfile);
      writeln('Finished with reading file');
   end;

begin { main }
  readfile;
   sortname;   {  sort by name option }
 { sortcall;  }{ sort by callsign   }
 { listfile;  }{ list the entire file}
 { listcall;  }{ sorts out the NONE callsign }
   listsoft;    { soft copy of information  }
end.


