program sort;
  {LIST IDSFILE, COPY TO ANOTHER FILE. }
{$M 4900,2000}
uses wincrt,strings,wintypes,winprocs;
  const        max = 800;
  type
    name      = string[14];
    line      = string[254];
    person    = string[27];
    longname  = string[35];
    call      = string[8];

 sortfile  = record
                user: person;
                lstm: integer;
            callsign:  call;
           telephone: name;
           password : name;
     end;

 sysid  = record
                user: person;
                exfl: byte;
                lsto: name;
                lstm: integer;
                pass: name;
                acc:  byte;
                clr:  name;
                bsp:  char;
                lnf:  char;
                upc:  boolean;
                wid:  byte;
           address1:  longname;
           address2:  longname;
           callsign:  call;
          telephone: name;
     end;



var idfile : file of sysid;
     idrec : sysid;
     ch    : char;
     sp    : string[60];
     num_entries : integer;
     itemx : integer;
     level : integer;
     ll    : integer;
     storage : array[1..max] of sortfile;


Procedure WindowsMessageHandler;
var M : TMsg;
begin
  while PeekMessage(M,0,0,0,pm_Remove) do
  begin
    TranslateMessage(M);
    DispatchMessage(M);
  end;
end;

procedure listsoft;
 var x : integer;
begin
  writeln('A total of ',itemx-1, ' level ',ll,' users were processed...');
  for x := 2 to itemx  do
  begin
    WindowsMessageHandler;
    with storage[x] do
    writeln(
             lstm:3 ,   ' ' ,
             copy(user     +sp,1,20),
             copy(callsign +sp,1,9),
             copy(telephone+sp,1,15),
             copy(password +sp,9,6));
  end;
  writeln('Finished with level ',ll,' users...');
end;


Procedure sortname;
var
  nochange   : boolean;
  temp1      : sortfile;
  x          : integer;

begin    {this is a cheap bubble sort... of sorts (bad pun!) }
  {write(' Sorting'); }
  repeat
   { write ('.'); }
    nochange := true;
    for x := 1 to num_entries - 1 do
      if storage[x].user > storage[x+1].user then
        begin
          temp1 := storage[x];
          storage[x] := storage[x+1];
          storage[x+1] := temp1;
          nochange := false;
        end;
    num_entries := num_entries - 1;
    WindowsMessageHandler;
  until nochange;
  { writeln ('done '); }
end;


procedure readfile(ll : integer);
var short : string[4];
       ss : string[1];
       i : integer;

  begin
     num_entries := 0;
     itemx := 0;
      sp        := '                                            ';
      assign(idfile,'\bbs\ids.bbs');
      {$I-} reset(idfile) {$I+};
      if ioresult = 0 then
      begin
         num_entries := 1;
         itemx := 1;
         while not (eof(idfile) or (itemx = max)) do
         begin
          read(idfile, idrec);
          WindowsMessageHandler;
          if ((idrec.user <> '***') and (idrec.acc = ll)) then
          begin
            storage[itemx].user      := idrec.user;
            storage[itemx].lstm      := itemx;
            storage[itemx].callsign  := idrec.callsign;
            storage[itemx].telephone := idrec.telephone;
            storage[itemx].password  := idrec.lsto  {pass};
            num_entries := num_entries + 1;
            itemx := itemx + 1;
          end;
         end;
      end;
      close(idfile);
   end;

begin { main }

  AutoTracking := false;
  ScreenSize.X := 60;
  ScreenSize.Y := max;
  StrCopy(WindowTitle,'AA6ED Modem BBS Sorted User ID Listing');
   for level := 0 to 10 do
   begin
     ll := 10 - ord(level);
     {writeln('Processing level ',ll,' users..');}
     readfile(ll);
     sortname;    {  sort by name option }
     listsoft;    { soft copy of information  }
     writeln;
     writeln;
   end;
end.

 { sortcall;  }{ sort by callsign   }
 { listfile;  }{ list the entire file}
 { listcall;  }{ sorts out the NONE callsign }

{*********   spare procedures  ************}
Procedure sortcall;
var
  nochange   : boolean;
  temp1      : sysid;
  x          : integer;

begin    {this is a cheap bubble sort... of sorts (bad pun!) }
  write(' Sorting');
  repeat
    write ('.');
    nochange := true;
    for x := 1 to num_entries - 1 do
      if storage[x].callsign > storage[x+1].callsign then
        begin
          temp1 := storage[x];
          storage[x] := storage[x+1];
          storage[x+1] := temp1;
          nochange := false;
        end;
    num_entries := num_entries - 1;
  until nochange;
  writeln ('done ');
end;


procedure listcall;
 var x : integer;

begin
  for x := 2 to itemx do
  begin
    with storage[x] do
    if callsign <> 'NONE' then writeln(
             lstm:3 ,   ' ' ,
             acc:1 , ' ' +
             copy(user     +sp,1,21) +
             copy(callsign +sp,1,9)  +
             {
             copy(address1 +sp,1,34) +
             copy(address2 +sp,1,33)    +
             }
             copy(telephone+sp,9,15) +
             password);
  end;
end;