procedure TCPIP(Menu_Option : integer);
var inch : line;


const
     maxTCPIPmessage = 250;
type
       TCPIPRecordType = record
           startline : integer;
           endline   : integer;
           SubjectTitle : string[60];
        end;
var
       TCPIPRecord : array[1..250] of TCPIPRecordType;
       messagecount : integer;
       AreaSelected : string40;
       Areaxx       : name;


procedure listtitles;
var count : integer;
    out_count : integer;
begin
   out_count := 0;
   lineout('MSG     '+areaxx);
   lineout('==   =======================================');
   for count := 1 to messagecount do
   begin
    lineout(istring(count) +'  '+ TCPIPRecord[count].SubjectTitle);
    if out_count > 24 then
    begin
     out_count := 0;
     press_return;
    end;
   end;
   lineout('Finis...');
   if out_count > 10 then press_return;
end;


procedure gettitles(filename :string);
var
       line        : string[128];
       infile      : text;
       start       : boolean;
       index,colon,linenumber : integer;
begin
      assign(infile,filename);
      {$I-} reset(infile) {$I+};
      if ioresult <> 0 then
      begin
        lineout('Could not find your Area...');
        exit;
      end;
      lineout('Area selected is '+areaxx);
      linenumber := 0;
      messagecount := 1;
      start := false;
      while not eof(infile) do
      begin
          readln(infile, line);
          linenumber := linenumber + 1;
         

          { Check for First occurance of from  }
          if (pos('From ',line) = 1) then Start := true;
        
          {  Clear out Received:'s, move startline }
          index := pos('Received:',line);
          if index = 1 then TCPIPRecord[messagecount].startline := linenumber+2;

          { Grab Subject  }
          index := pos('Subject:',line);
          colon := pos(':',line) + 1;
          if (index =1) then TCPIPRecord[messagecount].SubjectTitle :=
                   copy(line,colon,colon + 60);

          if (start and (length(line)=0)) then start := false ;
          if not start then   { find end of text in document }
          begin
            start := true;
            repeat
               readln(infile, line);
               linenumber := linenumber + 1;
            until ((pos('From ',line) = 1) or eof(infile));
            TCPIPRecord[messagecount].endline := linenumber{ ***  - 1};
            messagecount := messagecount + 1;
            if (pos('From ',line)=1) then
                TCPIPRecord[messagecount].startline := linenumber;
            if (messagecount > maxTCPIPmessage) then exit;
          end;    { loop to skip message text }
      end;        { loop to read file  }
      messagecount := messagecount - 1;
      close(infile);
end;


procedure SelectArea;
var
   prompt: line;
   inch : line;
begin
   Statusline1(2,'AreaSelect...');
   flush;
   if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
   if inbuffer = '' then
   begin
     FileList(maillistpath + '*.txt');
     lineout         ('Area must be selected from the above choices...');
     lineout         ('Please input the full name of the area, example  Area : TCPGROUP <cr> ');
   end;
   inch := allcaps(getinput('main\TCPIP MENU - Press return to EXIT or Select Area : ',12,echo));
   if ((length(inch) <> 0) and (inch <> calls) and (good_call_sign(inch))) then
   begin
     lineout('Access to this AREA is denied....');
     exit;
   end;
   if (length(inch) <> 0) then AreaSelected := maillistpath + inch else exit;
   if (pos('.',AreaSelected) = 0) then AreaSelected := AreaSelected + '.TXT';
  { writeln('[',areaselected,']'); xxxxxxxx 103:97d3 error  }
   StatusLine1(3,'AREA = '+AreaSelected);
   areaxx := inch;
   flush;
   gettitles(AreaSelected);
   ListTitles;
end;


procedure readmessage(filename: string; message:integer);
var linenumber : integer;
      infile      : text;
      line        : string[128];
      line_count  : integer;
      temp        : char;
type
     badwords = array[1..11] of string[21];
const
      badword : badwords =
            ('Path:',
             'Newsgroups:',
             'Keywords:',
             'Message-ID:',
             'Article-I.D.:',
             'References:',
             'NNTP-Posting-Host:',
             'Errors-To:',
             'Precedence:',
             'Message-Id:',
             'Status:');
 var  badcount,i : integer;
const dashes = '===========================================================';
begin
      if message = 0 then exit;
      linenumber := 1;
      line_count := 0;
      assign(infile,filename);
      {$I-} reset(infile) {$I+};
      if ioresult <> 0 then
      begin
        Stringout('Error: Could not find input file');
        exit;
      end;
      lineout(dashes);
      lineout('Msg: '+istring(message)+' Subject: '+TCPIPRecord[message].subjecttitle);
      lineout(dashes);
      while ((not eof(infile)) and (linenumber < TCPIPRecord[message].endline)) do
      begin
          readln(infile, line);
          if linenumber >= TCPIPRecord[message].startline then
          begin
            badcount := 0;
            for i := 1 to 11 do badcount := badcount + pos(badword[i],line);
            if badcount = 0 then
            begin
               lineout(line);
               line_count := line_count + 1;
               if (line_count > 24) then
               begin
                 line_count := 1;
                 press_return;
               end;
            end;
          end;
          linenumber := linenumber + 1;
      end;        { loop to read file  }
      close(infile);
      lineout('Finis...');
      press_return;
end;

function TCPIPRead: integer;
var i, selection : integer;
begin
  if inbuffer <> '' then for i := 1 to length(inbuffer) do
     if inbuffer[i] = ' ' then inbuffer[i] := ';';
  repeat
     selection :=  getint(messagecount,0,'Enter Message Number to Read (0 to quit) : ');
     readmessage(AreaSelected, selection);
  until inbuffer = '';
  TCPIPRead := selection;
end;

{begin TCPIP main menu}
procedure Main_Menu;
var i : integer;
    prompt : line;
    inch1 : char;
  begin
    messagecount := 0;
    StatusLine1(4,'TCPIP Read...');
    AreaSelected := calls;
    if calls = 'NONE' then AreaSelected := 'Bulletin';
    if access < HAM_MSYS then AreaSelected := 'Bulletin';
    i := pos('-',AreaSelected);
    if i<> 0 then AreaSelected := copy(AreaSelected,1,i-1);
    i := pos('/',calls);
    if i<> 0 then AreaSelected := copy(AreaSelected,1,i-1);
    areaxx := AreaSelected;
    lineout('Default Area is '+areaxx);
    AreaSelected := maillistpath +AreaSelected + '.TXT';
    GetTitles(AreaSelected);
    file_control_enable := true;
    if (MessageCount <> 0) then
    begin
       ListTitles;
       TCPIPRead;
    end;
    repeat
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if ((not expert) and (inbuffer = '')) then outfile(TCPIPMenu);
      prompt := cr + lf + 'main\TCPIPmenu (?-help) cmd: ';
      if not expert then prompt := prompt + '[A,D,L,W,R,G,?] : ';
      flush;
      inch1 := getcap(prompt);
      case inch1 of
        'A': SelectArea;  { electronic mail }
        'D': Outfile(AreaSelected);
        'W': begin
               outfile(areasfilepath);
               SelectArea;
             end;
        'L': if messagecount = 0 then
             begin
               gettitles(AreaSelected);
             end
             else listtitles;
        'G': inbuffer := '-;G';
        'R': TCPIPRead;
        '?': if expert then outfile(TCPIPMenu);
        '-': begin end;
        else  ErrorCode(inch1);
      end;
    until ((inch1 ='-') or (inch1 = cr) or not cts);
    file_control_enable := false;
  end; {command}


procedure Bulletin_Menu;
 var i : integer;
    prompt : line;
    inch1 : char;
    selection : integer;
  begin

    messagecount := 0;
    StatusLine1(4,'TCPIP Bulletin Read...');
    AreaSelected := 'Bulletin';
    areaxx := AreaSelected;
    AreaSelected := maillistpath +AreaSelected + '.TXT';
    GetTitles(AreaSelected);
    file_control_enable := true;
    if (MessageCount <> 0) then
    begin
      repeat
        ListTitles;
        selection := TCPIPRead;
        if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      until ((selection = 0) or not cts);
    end;
    file_control_enable := false;
end;

{ main function }
begin
  FILEMODE := 0;       { Read only }
  case Menu_Option of
    0 : Main_Menu;
    1 : Bulletin_Menu;
  end;
  FILEMODE := 2;       { Read/Write }
end;

