

 { variable list   }

const
  clockin = true;  { Set to false if no clock available. }
  sectsin = true;  { Use to turn section feature on/off. }
  openBBS = true;  { Selects a private or public system. }

  { Control Files  }
messdrive    = 'E:\BBS\MESSAGE\';  { Drive on which messages go }
commentsfile = 'E:\BBS\COMMENTS.BBS';
applyfile    = 'E:\BBS\APPLY.BBS';

  { tcpip.inc constants }
maillistpath  =  'e:\nos\spool\mail\';  { directory of mail }
areasfilepath =  'e:\nos\spool\areas';  { location of areas file }

const
  numsects = 43;
type
  filedrivenamedef = array[1..numsects] of string[25];
  sectname = array[1..numsects] of string[40];
const
sect1 : sectname = (
 '1:  DOS Utilities',    '2:  Apple Macintosh',    '3:  Packet / Digital', '4:  Communications',
 '5:  Digital',          '6:  Sanyo 555 Computer', '7:  General Software', '8:  TCP/IP',
 '9:  Pascal Source',   '10:  C and C++ Source',   '11: Windows 3.0',     '12: General Files',
'13:  BBS Applications','14:  Antennas',           '15:  Clubs Info',     '16:  Contest',
'17:  Control',         '18:  CW/Morse Code',      '19:  DX',             '20:  FCC Exams',
'21:  Facimile (FAX)',  '22:  FCC Info',           '23:  Frequencies',    '24:  Glossary',
'25:  Kenwood Radios',  '26:  Local Area Networks','27:  Logging/loggers','28:  Maps',
'29:  Math Utilities',  '30:  Misc Stuff',         '31:  Modifications',  '32:  Oscar',
'33:  PK-232 TNC',      '34:  QSL',                '35:  Regulations',    '36:  RTTY',
'37:  Satellites',      '38:  Space',              '39:  Slow Scan TV',   '40:  SWL',
'41:  Technical',       '42:  Utilities',          '43:  AA6ED Private');

filedrivename : filedrivenamedef = (
'E:\PUBLIC\DOS\',     'E:\PUBLIC\APPLE\',    'E:\PUBLIC\PACKET\',  'E:\PUBLIC\COMM\',
'E:\PUBLIC\DIGITAL\', 'E:\PUBLIC\SANYO555\', 'E:\PUBLIC\GSOFT\',   'E:\PUBLIC\TCPIP\',
'E:\PUBLIC\PASCAL\',  'E:\PUBLIC\CPLUSS\',   'E:\PUBLIC\WINDOWS\', 'E:\PUBLIC\GENERAL\',
'E:\PUBLIC\BBS\',     'E:\PUBLIC\ANTENNA\',  'E:\PUBLIC\CLUB\',    'E:\PUBLIC\CONTEST\',
'E:\PUBLIC\CONTROL\', 'E:\PUBLIC\CW\',       'E:\PUBLIC\DX\',      'E:\PUBLIC\EXAM\',
'E:\PUBLIC\FAX\',     'E:\PUBLIC\FCC\',      'E:\PUBLIC\FREQ\',    'E:\PUBLIC\GLOSS\',
'E:\PUBLIC\KENWOOD\', 'E:\PUBLIC\LAN\',      'E:\PUBLIC\LOG\',     'E:\PUBLIC\MAPS\',
'E:\PUBLIC\MATH\',    'E:\PUBLIC\MISC\',     'E:\PUBLIC\MODS\',    'E:\PUBLIC\OSCAR\',
'E:\PUBLIC\PK232\',   'E:\PUBLIC\QSL\',      'E:\PUBLIC\REGS\',    'E:\PUBLIC\RTTY\',
'E:\PUBLIC\SATEL\',   'E:\PUBLIC\SPACE\',    'E:\PUBLIC\SSTV\',    'E:\PUBLIC\SWL\',
'E:\PUBLIC\TECH\',    'E:\PUBLIC\UTILS\',    'E:\PRIVATE\'
);


  { Welcome files  }
  applying           = 'E:\BBS\INFO\APPLYING.TXT';
  welcome            = 'E:\BBS\INFO\WELCOME.TXT';
  WelcomePacket      = 'E:\BBS\INFO\PackInfo.TXT';
  Welcome1    = 'E:\BBS\INFO\Welcome1.TXT';
  helpfile     = 'E:\BBS\INFO\BBSHELP.TXT';
  sysinfo      = 'E:\BBS\INFO\SYSINFO.TXT';
  filehelp     = 'E:\BBS\INFO\FILEHLP.TXT';
  JNOSInfo     = 'E:\BBS\INFO\JNOSInfo.TXT';

  {  Unused Code
  bulletin     = 'E:\BBS\INFO\BULLETIN.TXT';
  PacketFile   = 'E:\BBS\INFO\PACKET.TXT';
  MSYSPassword = 'E:\MSYS\MSYSPASS.MOD';
  }

  { Menu Files }
  mainmenu     = 'E:\BBS\INFO\MAINMENU.TXT';
  readmenu     = 'E:\BBS\INFO\READMENU.TXT';
  filemenu     = 'E:\BBS\INFO\FILEMENU.TXT';
  editmenu     = 'E:\BBS\INFO\EDITMENU.TXT';
  infomenu     = 'E:\BBS\INFO\INFOMENU.TXT';
  systmenu     = 'E:\BBS\INFO\SYSTMENU.TXT';
  messmenu     = 'E:\BBS\INFO\MESSMENU.TXT';
  Packmenu     = 'E:\BBS\INFO\PACKMENU.TXT';
  TCPIPMenu    = 'E:\BBS\INFO\TCPIP.TXT';

  Sysop    = 10;  { Access levels }
  HAM_BBS  =  6;
  HAM_Gate =  5;
  HAM_Msys =  4;
  FILE_reg =  3;
  reg      =  2;
  newuser  =  1;
  twit     =  0;

  noecho    = false;
  echo      = true;
  null      = #0;
  abort     = #3;
  bell      = #7;
  bksp      = #8;
  tab       = #9;
  lnfd      = #10;
  cr        = #13;
  pause     = #19;
  esc       = #27;
  space     = ' ';

type
  name      = string[14];
  call      = string[8];
  longname  = string[35];
  maxstr    = string[255];
  line      = string[255];   { was 80 *** }
  person    = string[27];
  string150 = string[150];
  string40  = string[40];
  filbuffer = array[0..127] of byte;
  sysid     = record
                user      : person;
                exfl      : byte;
                lsto      : name;
                lstm      : integer;
                pass      : name;
                acc       : byte;
                clr       : name;
                bsp       : char;
                lnf       : char;
                upc       : boolean;
                wid       : byte;
                address1  : longname;
                address2  : longname;
                callsign  : call;
                telephone : name;
              end;
  log       = record
                who       : integer;
                when      : name;
                done      : name;
              end;
  yesno     = array[boolean] of string[3];

const
  yn: yesno    = ('NO','YES');
  timeout      = 256;
  loopspersec  = 6500;
  sp           = '                         ';

var
  baud : integer;
  verylongname : string40;
  message     : maxstr;
  buffer      : string150;

  {File i/o variables}
  idfile      : file of sysid;
  idrec       : sysid;

  {Temporary userid information}
  caller      : person;       { user name }
  access      : byte;
  add1,
  add2        : longname;
  calls       : call;
  tele,
  password,
  timeon,
  timeoff     : name;
  caps        : boolean;
  bl, lf, bs  : char;
  cs          : name;         { clear screen }
  width       : integer;
  expert      : boolean;

  usercount   : integer;  { tracks number of users since last boot }


  {Integers}
  usernum,
  lastmess,
  nextmess,
  charcount,
  lastspace,
  bufpointer : integer;

  {Booleans}
  controls,
  printon,
  local,
  filesopen,
  messopen : boolean;

  {Characters}
  exitchar : char;

  {Clock and timer parameters}
  sec,   onsec,   offsec   : word;
  min,   onmin,   offmin   : word;
  hour,  onhour,  offhour  : word;
  date,  ondate,  offdate  : word;
  month, onmonth, offmonth : word;
  usesec, usemin, usehour  : integer;

  {Controls the S and C flow control for the CharOut Procedure}
  file_control_enable: boolean;

      {Line Status Registers  }
          ComBase_LSR,
          PacketBase_LSR,
          MSYSBase_LSR   : integer;

          {Modem Status Registers  }
          ComBase_MSR,
          PacketBase_MSR,
          MSYSBase_MSR   : integer;


{EOF }