{Include file for MainWindow; }

const
AppName: PChar = 'WinBBS';

  id_Rad0   = 200;
  id_Rad1   = 201;
  id_Rad2   = 202;
  id_Rad3   = 203;
  id_Rad4   = 204;
  id_Rad5   = 205;
  id_Rad6   = 206;
  id_Rad7   = 207;
  id_Rad8   = 208;
  id_Rad9   = 209;
  id_Rad10  = 210;
  id_Name   = 101;
  id_Call   = 102;
  id_add1   = 103;
  id_add2   = 104;
  id_Tele   = 105;
  id_lsto   = 301;
  id_on     = 302;
  id_baud   = 303;
  id_kill   = 601;
  id_Save   = 602;
  id_status1   = 616;
  id_status2   = 617;
  id_status3   = 618;
  id_status4   = 619;
  id_editbox   = 900;

type
  TransferUserParameters = record
    Sysop    : Bool;
    Ham_BBS  : Bool;
    HAM_Gate : Bool;
    HAM_Msys : Bool;
    FileX    : Bool;
    Reg      : Bool;
    New      : Bool;
    Twit     : Bool;
    OnStat  : array[0..14] of Char;
    LstoStat: array[0..14] of Char;
    BaudStat: array[0..10] of Char;
    NameEdit: array[0..27] of Char;
    CallEdit: array[0..8]  of Char;
    Add1Edit: array[0..35] of Char;
    Add2Edit: array[0..35] of Char;
    TeleEdit: array[0..14] of Char;
  end;

 var
   TeleLSR : array[0..3] of Char;
   GateLSR : array[0..3] of Char;
   BridgeLSR : array[0..3] of Char;
   TeleMSR : array[0..3] of Char;
   GateMSR : array[0..3] of Char;
   BridgeMSR : array[0..3] of Char;
   DialogWindow : HWnd;
   Returnvalue : integer;
   UserParameters: TransferUserParameters;
   R100: PRadioButton;
   S301: PEdit;
   S302: PEdit;
   S303: PEdit;
   E101: PEdit;
   E102: PEdit;
   E103: PEdit;
   E104: PEdit;
   E105: PEdit;

   { Status display  }
   E616 : PEdit;
   E617 : PEdit;
   E618 : PEdit;
   E619 : PEdit;
   E900 : PEdit;

type
  PMBBS = ^TMBBS;
  TMBBS = object(TDlgWindow)
      constructor Init;
      destructor Done; virtual;
      procedure HandleAccess0(var Msg: TMessage);  virtual id_First + id_rad0;
      procedure HandleAccess1(var Msg: TMessage);  virtual id_First + id_rad1;
      procedure HandleAccess2(var Msg: TMessage);  virtual id_First + id_rad2;
      procedure HandleAccess3(var Msg: TMessage);  virtual id_First + id_rad3;
      procedure HandleAccess4(var Msg: TMessage);  virtual id_First + id_rad4;
      procedure HandleAccess5(var Msg: TMessage);  virtual id_First + id_rad5;
      procedure HandleAccess6(var Msg: TMessage);  virtual id_First + id_rad6;
      procedure HandleAccess10(var Msg: TMessage); virtual id_First + id_rad10;
      procedure HandleID_Kill(var Msg: TMessage);  virtual id_First + id_kill;
      procedure HandleID_Save(var Msg: TMessage);  virtual id_First + id_save;
      procedure WMTimer(var Msg: TMessage);        virtual wm_Timer + wm_First;
      procedure WMInitDialog(var Msg: TMessage);   virtual wm_First + wm_InitDialog;
      procedure GetWindowClass(var AWndClass: TWndClass); virtual;
      procedure DefChildProc(var Msg: TMessage);          virtual;
      function GetClassName: PChar;                       virtual;
  end;

  procedure ql;
  begin
    StatusLine(4,'Access='+IString(access));
    WmCommandWord := 0;
    messagebeep(0);
  end;

  procedure TMBBS.HandleAccess10(var Msg: TMessage); begin access := Sysop;    QL; end;
  procedure TMBBS.HandleAccess6(var Msg: TMessage);  begin access := HAM_BBS;  QL; end;
  procedure TMBBS.HandleAccess5(var Msg: TMessage);  begin access := HAM_Gate; QL; end;
  procedure TMBBS.HandleAccess4(var Msg: TMessage);  begin access := Ham_MSYS; QL; end;
  procedure TMBBS.HandleAccess3(var Msg: TMessage);  begin access := File_Reg; QL; end;
  procedure TMBBS.HandleAccess2(var Msg: TMessage);  begin access := reg;      QL; end;
  procedure TMBBS.HandleAccess1(var Msg: TMessage);  begin access := newuser;  QL; end;
  procedure TMBBS.HandleAccess0(var Msg: TMessage);  begin access := twit;     QL; end;


  procedure TMBBS.HandleID_Kill(var Msg: TMessage);
  begin
    if cts then hangup else Statusline(0,'Killed...');
  end;

  procedure TMBBS.HandleID_Save(var Msg: TMessage);
  begin
   GetDlgItemText(DialogWindow,id_name,UserParameters.NameEdit,SizeOf(UserParameters.NameEdit));
   GetDlgItemText(DialogWindow,id_call,UserParameters.CallEdit,SizeOf(UserParameters.CallEdit));
   GetDlgItemText(DialogWindow,id_add1,UserParameters.Add1Edit,SizeOf(UserParameters.Add1Edit));
   GetDlgItemText(DialogWindow,id_add2,UserParameters.Add2Edit,SizeOf(UserParameters.Add2Edit));
   GetDlgItemText(DialogWindow,id_tele,UserParameters.TeleEdit,SizeOf(UserParameters.TeleEdit));
   caller := StrPas(UserParameters.NameEdit);
   calls  := StrPas(UserParameters.CallEdit);
   add1   := StrPas(UserParameters.Add1Edit);
   add2   := StrPas(UserParameters.Add2Edit);
   tele   := StrPas(UserParameters.TeleEdit);
   messagebeep(0);
  end;

  procedure UserParameter_Update;
  var button_set : integer;
  begin
    with UserParameters do
    begin
      StrPCopy(NameEdit,caller);
      StrPCopy(CallEdit,calls);
      StrPCopy(Add1Edit,add1);
      StrPCopy(Add2Edit,add2);
      StrPCopy(TeleEdit,tele);
      StrPCopy(OnStat,timeon);
      StrPCopy(LstoStat,idrec.lsto);
      Sysop    := false;
      HAM_BBS  := false;
      HAM_Gate := false;
      HAM_MSYS := false;
      FileX := false;
      Reg   := false;
      New   := false;
      Twit  := false;
      case access of
       10 : begin Sysop    := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad10);  end;
        6 : begin HAM_BBS  := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad6);  end;
        5 : begin HAM_Gate := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad5);  end;
        4 : begin Ham_MSYS := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad4);  end;
        3 : begin FileX    := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad3);  end;
        2 : begin Reg      := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad2);  end;
        1 : begin New      := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad1);  end;
        0 : begin Twit     := true; CheckRadioButton(DialogWindow,id_Rad0,id_Rad10,id_Rad0);  end;
      end;
    end;
    SetDlgItemText(DialogWindow,id_Name,UserParameters.NameEdit);
    SetDlgItemText(DialogWindow,id_Call,UserParameters.CallEdit);
    SetDlgItemText(DialogWindow,id_Add1,UserParameters.Add1Edit);
    SetDlgItemText(DialogWindow,id_Add2,UserParameters.Add2Edit);
    SetDlgItemText(DialogWindow,id_Tele,UserParameters.TeleEdit);
    SetDlgItemText(DialogWindow,id_On,  UserParameters.OnStat);
    SetDlgItemText(DialogWindow,id_Lsto,UserParameters.LstoStat);
    SetDlgItemText(DialogWindow,id_Baud,UserParameters.BaudStat);
  end;


  procedure StatusLine(linenr : integer; textline : line);
  var message : line;
      yline : line;
  var outputline : array[0..127] of char;
  begin
   clock(month,date,hour,min,sec);
   message := time(month, date, hour, min, sec);
   if linenr <> 0 then SetDlgItemText(DialogWindow,615+linenr,StrPCopy(outputline,textline));
   yline := message+'  '+IString(linenr)+': '+textline;
   writeln(yline);
  end;

  procedure StatusLine1(linenr : integer; textline : person);
  var outputline : array[0..127] of char;
  begin
   SetDlgItemText(DialogWindow,615+linenr,StrPCopy(outputline,textline));
  end;

 type
  TMBBSApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;


{ Entry Point for timer fix }
procedure TMBBS.WMTimer(var Msg: TMessage);
begin
 KillTimer(HWindow,1);
 DialogWindow := HWindow;
 MainEngine;
 KillTimer(HWindow,1);
 CloseCommPorts(3);
 DoneWinCrt;
 TDlgWindow.Done;
end;

constructor TMBBS.Init;
begin
  TDlgWindow.Init(nil, AppName);
end;

destructor TMBBS.Done;
begin
   KillTimer(HWindow,1);
   CloseCommPorts(3);
   DoneWinCrt;
   TDlgWindow.Done;
end;

procedure TMBBS.WMInitDialog(var Msg: TMessage);
var ch : char;
begin
   TWindowsObject.SetupWindow;
   SetTimer(HWindow,1,3000,nil);
end;

var
{ Application instance }
  MBBSApp: TMBBSApp;

function TMBBS.GetClassName: PChar;
begin
  GetClassName := AppName;
end;

procedure TMBBS.GetWindowClass(var AWndClass: TWndClass);
begin
  TDlgWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, Appname);
end;

procedure TMBBS.DefChildProc(var Msg: TMessage);
begin
  TDlgWindow.DefChildProc(Msg);
end;

procedure TMBBSApp.InitMainWindow;
begin
  MainWindow := New(PMBBS, Init);
  New(R100, InitResource(MainWindow, id_Rad0));
  New(R100, InitResource(MainWindow, id_Rad1));
  New(R100, InitResource(MainWindow, id_Rad2));
  New(R100, InitResource(MainWindow, id_Rad3));
  New(R100, InitResource(MainWindow, id_Rad4));
  New(R100, InitResource(MainWindow, id_Rad5));
  New(R100, InitResource(MainWindow, id_Rad6));
  New(R100, InitResource(MainWindow, id_Rad7));
  New(R100, InitResource(MainWindow, id_Rad8));
  New(R100, InitResource(MainWindow, id_Rad9));
  New(R100, InitResource(MainWindow, id_Rad10));
  New(S301, InitResource(MainWindow, id_On,   SizeOf(UserParameters.OnStat)));
  New(S302, InitResource(MainWindow, id_Lsto, SizeOf(UserParameters.LstoStat)));
  New(S303, InitResource(MainWindow, id_Baud, SizeOf(UserParameters.BaudStat)));
  New(E101, InitResource(MainWindow, id_Name, SizeOf(UserParameters.NameEdit)));
  New(E102, InitResource(MainWindow, id_Call, SizeOf(UserParameters.CallEdit)));
  New(E103, InitResource(MainWindow, id_Add1, SizeOf(UserParameters.Add1Edit)));
  New(E104, InitResource(MainWindow, id_Add2, SizeOf(UserParameters.Add2Edit)));
  New(E105, InitResource(MainWindow, id_Tele, SizeOf(UserParameters.TeleEdit)));

  New(E616, InitResource(MainWindow, id_Status1, SizeOf(person)));
  New(E617, InitResource(MainWindow, id_Status2, SizeOf(person)));
  New(E618, InitResource(MainWindow, id_Status3, SizeOf(person)));
  New(E619, InitResource(MainWindow, id_Status4, SizeOf(person)));
  New(E900, InitResource(MainWindow, id_editbox, 1050));  {2650}
end;


Procedure WindowsMessageHandler;
var M : TMsg;
begin
    while PeekMessage(M,0,0,0,pm_Remove) do
    begin
      TranslateMessage(M);
      DispatchMessage(M);
    end;
end;

procedure delay(xxxx : integer);
 begin
   TimeOutTimer := false;
   SetTimer(CrtWindow,0,xxxx,nil);
   WaitMessage;
   while not TimeOutTimer do WindowsMessageHandler;
 end;

procedure Clock(var month,date,hour,min,sec: word);
var hundredths,year,dayofweek : word;
begin
   GetTime(hour,min,sec,hundredths);
   GetDate(year,month,date,dayofweek);
end;


  {LIST comment file }
procedure ListCommentFile;
begin end;
{
type  line      = string[80];
var   idyfile : file of line;
      lx   : line;
  begin

      assign(idyfile,'\bbs\comments.bbs');
      x$I-x reset(idyfile) x$I+x;
      if ioresult = 0 then
      begin
         while not eof(idyfile) do
           BEGIN
             read(idyfile, lx);
             writeln(lx);
           END;
      end;
      close(idyfile);
      writeln('Finished with listing');
   end;
   }

   { Finger command accessed from main menu }
   procedure finger;
   var number,inch : integer;
         temp : line;
   begin
     assign(idfile,'\BBS\IDS.BBS');
     FileMode := 0;  {0=Read only 2=ReadWrite}
     reset(idfile);
     local := true;
     setlocal;
     repeat
      number := getid('User name or callsign? ');
      if (number = 0) then writeln('User not found... (enter SYSOP to exit)...');
     until (number <> 0);
     if number > 1 then
     begin
       writeln('---------------------------------');
       writeln(idrec.user);
       writeln(idrec.address1);
       writeln(idrec.address2);
       writeln(idrec.callsign);
       writeln(idrec.telephone);
       writeln(idrec.pass);
       writeln('LastON',idrec.lsto);
       str(idrec.acc:2, temp);
       writeln('Access:' + temp);
       inch := getint(10, 0, 'New level? ');
       if inch > 0 then
       begin
         idrec.acc := inch;
         FileMode := 2;  {0=Read only 2=ReadWrite Update user}
         reset(idfile);
         seek(idfile, number - 1);
         write(idfile, idrec);
         writeln('User ',idrec.user,' access is now ',idrec.acc);
      end else writeln('Cannot set 00 from here..');
     end
     else writeln('User not found...');
     close(idfile);
     local := false;
     clearlocal;
  end;

  procedure Xfinger;
   var number,inch : integer;
        temp1,temp : line;
             index : integer;
   begin
    temp := allcaps(getinput('Enter Name or Callsign :  ', 28, echo));
    lineout('Searching userlist...');
    FileMode := 0;  {0=Read only 2=ReadWrite}
    {$I-} reset(idfile) {$I+};
    if IOresult <> 0 then exit;
    while ((not eof(idfile)) and cts and (not inready)) do
    begin
      index := 0;
      read(idfile, idrec);
      index := pos(temp,idrec.user);
      index := index + pos(temp,idrec.callsign);
      if index > 0 then
      begin
        Lineout('---------------------------------');
        lineout('USER: '+idrec.user);
        lineout('CALL: '+idrec.callsign);
        lineout('LsON: ' + idrec.lsto);
        if access = sysop then
        begin
          lineout('ADD1: '+idrec.address1);
          lineout('ADD2: '+idrec.address2);
          lineout('TELL: '+idrec.telephone);
          lineout('PASS: '+idrec.pass);       
          str(idrec.acc:2, temp1);
          lineout('ACC :  ' + temp1);
        end;     
      end;
    end;
  end;


{ end of control include file  }
