


function Server_Send(s : integer; message : string): integer;
var status : integer;
begin
    status := send(s,PChar(@message[1]), Length(message),0);
    if (status < 0)  then
    begin
      writeln('Unable to send ',message, ' to socket ', s);
      WSACleanup;
      exit;
    end;
    Server_Send := status;
end;

function Server_Receive(s : integer): string;
var
 len : integer;
 message : string;
const
 lost : string = 'Socket lost...';
begin
  message[0] := #0;
  if (s <> 0) then
  begin
   len := recv(s, PChar(@message[1]), 255,0);
   message[0] := char(len);
   if (len = 0) then
   begin
    WSACleanup;
    lineout (lost);
   end;
 end;
 Server_receive := message;
end;

function Server_Disconnect(s : integer) : integer;
begin
  WSACleanup;
  writeln('Cleanup completed for socket ',s,'...');
end;

function open_client(hostname : string; portnumber : integer): integer;
var
  phe	  : PHostEnt;
  pa	  : PChar;
  sz      : array [1..64] of char;
  sa	  : in_addr;
  FSocket : integer;
  e       : integer; { reusable }

  ps	: PServEnt;
  proto	: array [1..32] of char;
  name : array [1..64] of char;
  portn : array [1..32] of char;
  myVerReqd : word;
  myWSAData : WSADATA;

  peeraddr_in : sockaddr_in;
  dummy : Psockaddr;

begin
        myVerReqd:=$0101;
        peeraddr_in.sin_family := PF_INET;
       {	peeraddr_in.sin_addr.s_addr := INADDR_ANY;   }
        peeraddr_in.sin_port := 0;

	if( WSAStartup(myVerReqd,@myWSAData) <> 0) then
        begin
		writeln('Can''t startup WinSock');
                exit;
        end;
      {  writeln('Gethostbyname=',hostname); }
	StrPCopy(@sz, hostname);
	phe := gethostbyname(@sz);
	if phe <> nil then
	begin
	  pa := phe^.h_addr_list^;
	  sa.S_un_b.s_b1:=pa[0];
	  sa.S_un_b.s_b2:=pa[1];
	  sa.S_un_b.s_b3:=pa[2];
	  sa.S_un_b.s_b4:=pa[3];
          peeraddr_in.sin_addr := sa;
       end
 else
   writeln('Can''t find host ' + hostname);

   if (portnumber = 0) then
   begin
	StrPCopy(@proto, 'tcp');
	StrPCopy(@name, '127.0.0.1');
	ps := getservbyname(@name, @proto);
	if ps <> nil then
		peeraddr_in.sin_port := htons(ps^.s_port)
	else
		peeraddr_in.sin_port := htons(portnumber);
   end
   else
       peeraddr_in.sin_port := htons(portnumber);

   FSocket := _socket(AF_INET,SOCK_STREAM,0);
   if (FSocket = 0) then
   begin
     writeln('Unable to create socket.');
     WSACleanup;
     exit;
   end;

   if (FSocket > 0) then
   begin
     if connect(FSocket, PSockAddr(@peeraddr_in)^, SizeOf(peeraddr_in)) <> 0 then
       if WSAGetLastError <> WSAEWOULDBLOCK then
       begin
          e := WSAGetLastError;
	  if FSocket <> INVALID_SOCKET then
	    WSACleanup;
	  writeln('Connect failed... Error=',e, ' Socket=',FSocket);
          FSocket := 0;
       end;
   end;

    open_client := FSocket;
end;


function inchar: char;
var temp: char;
begin
  repeat until inready or not cts;
  if keypressed then temp := readkey else temp := recvchar;
  inchar := temp;
end;


procedure MSYS(link_to : string; portnumber : integer);
var inch,
    inch1 : char;
    lock_password: boolean;
    lock_login : boolean;
    lock_ready : boolean;
    destination : text;
    tempcall : string[10];
    i,counttime    : integer;
    rmessage : string;
    smessage : string;
    count : integer;
    time  : timeval;
    myset : fd_set;
    xxset : fd_set;
    xset  : integer;
    max_time : word;
    sport : integer; {the magic port }
    temp       : string[10];
    hostname   : string[255];
    MTU_MAX    : integer;

const
    anonymous : string = 'anonymous';



  begin
    if (( not expert) and (access <> HAM_bbs))
           then outfile(JNOSInfo);
    lineout('Entering TCIP Network Operating System link to '+link_to + '...');
    lineout('Auto-Login sequence started, PLEASE BE PATIENT!');
    lock_login := FALSE;
    lock_password := FALSE;
    lock_ready := FALSE;
    if (portnumber = 0) then portnumber := 23;
    MTU_MAX := 255;
    sport := open_client(link_to,portnumber);
    if (sport = 0) then  exit; { bail out here }
    count := 0;
    time.tv_sec := 0;
    time.tv_usec := 100000;
    inch := null;
    clearsc;
    tempcall := calls;
    File_Control_Enable := false;
    if calls = 'NONE' then tempcall := anonymous;
    if access < HAM_MSYS then tempcall := anonymous;
    i := pos('-',tempcall);
    if i<> 0 then tempcall := copy(tempcall,1,i-1);
    i := pos('/',calls);
    if i<> 0 then tempcall := copy(tempcall,1,i-1);

    counttime := 0;

    { main loop program }
    while ((sport <> 0) and cts and (inch <> ^T)) do
    begin
      WindowsMessageHandler;
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;


    if (lock_ready) then max_time := 6000 else max_time := 3000;

    xxset.fd_count := 0;
    myset.fd_count := 1;
    myset.fd_array[0] := sport;
    myset.fd_array[1] := sport;
    xset := select(1,myset,xxset,xxset,time);
    case xset of
    -1 :
         begin
           lineout('Error in SELECT...');
           Server_Disconnect(sport);
           sport := 0;
          end;
    1 :     { handle packets comming in over ethernet }
         begin
            counttime := 0;
            rmessage := Server_receive(sport);
            if (rmessage[0] = #0) then
              sport := 0
            else
              stringout(rmessage);
           if (not lock_ready) then   {HELL only one chance to login }
            begin
              if (pos('login:',rmessage) > 0) then
              begin
                tempcall := tempcall + cr + lf;
                 if access < HAM_MSYS then
                   tempcall := 'guest' + cr + lf;
                Server_send(sport,tempcall);
                lineout(tempcall);
                lock_login := TRUE;
              end;
              if (pos('Password:',rmessage) > 0) then
              begin
                if access < HAM_MSYS then
                  tempcall := 'NONE' + cr + lf
                else
                  tempcall := password + cr + lf;
                Server_send(sport,tempcall);
                lineout('******');
                lock_password := TRUE;
              end;
              if (lock_login and lock_password) then
              begin
                lock_ready := TRUE;
                stringout(bell + bell + bell);
              end;
           end;   {end lock ready}
         end;
     0 :       { handle keyboard and modem inputs }
          begin
            counttime := counttime + 1;   {the real timeout timer }
            if inready then
            begin
              counttime := 0;
              smessage := getinput('', MTU_MAX, ECHO);
              inch := smessage[1];
              if (lock_ready) then
                 Server_send(sport,smessage + cr + lf)
               else
                 stringout(bell);
            end;
          end;
      end; {case}

     if (counttime > max_time) then
     begin
       lineout(cr+lf+'SystemBBS has detected lack of activity and has timed out...');
       StatusLine(1,'Login timeout...');
       inch := ^T;
     end;

  end;  {end of MSYS do loop engine }

  lineout(cr +lf + 'Exiting TCPIP NOS Packet mode.');
  Server_Disconnect(sport);
 end;

procedure XPacketMenu;
var prompt : line;
      inch : char;
begin
 StatusLine(1,'PacketMenu...');
 Statusline1(2,'...');
 StatusLine1(3,'...');
 StatusLine1(4,'...');
  repeat
      if WMCommandWord = 1001 then begin chat; WMCommandWord := 0; end;
      if ((not expert) and (inbuffer = '')) then outfile(Packmenu);
      File_Control_Enable := false;
      prompt := cr + lf + 'main\PACKET MENU: ';
      if expert then prompt := prompt + '[T,1,2,3,4,5,6,7,?,-] : ';
      inch := getcap(prompt);
      case inch of
       '1',
       '2' : begin
               if access < reg then lineout('You are not a registered BBS User.')
               else
                begin
                 Statusline1(2,'TCPIP NOS Bridge');
                 case inch of
                  '1' : MSYS('aa6ed.ampr.org',23);
                  '2' : MSYS('server.aa6ed.ampr.org',23);
                end;
               end;
            end;
       '3',
       '4',
       '5',
       '6',
       '7'  : begin
               if access < HAM_Gate then lineout('You are not a registered HAM Gate User.')
               else
                begin
                 Statusline1(2,'TCPIP NOS Bridge');
                 case inch of
                  '3' : MSYS('n7qob.ampr.org',23);
                  '4' : MSYS('ethanac.kd7nm.ampr.org',23);
                  '5' : MSYS('seanvg.ampr.org',23);
                  '6' : MSYS('n7nei.ampr.org',23);
                  '7' : MSYS('kb6le.ampr.org',23);
                end;
               end;
            end;
       'T': TCPIP(0);
       '?': outfile(Packmenu);
       '-': begin end;
       cr : begin end;
       else ErrorCode(inch);
     end;
    until ((inch ='-') or (inch = cr) or not cts);
end;
{eof}